#include "CH58x_common.h"
#include "keyscan.h" 

#define key_state_0 0
#define key_state_1 1
#define key_state_2 2
#define key_state_3 3

#define KeyInput    GPIO_Pin_0

void Key_init(void)
{
    GPIOB_ModeCfg(GPIO_Pin_0, GPIO_ModeIN_PU);
    GPIOB_ITModeCfg(GPIO_Pin_0, GPIO_ITMode_FallEdge); // ½ػ
    PFIC_EnableIRQ(GPIO_B_IRQn);
    PWR_PeriphWakeUpCfg(ENABLE, RB_SLP_GPIO_WAKE, Long_Delay);
}

KEY_event_t key_read(void)
{
    static unsigned char key_state = key_state_0;
    static unsigned char key_time = 0;
    static unsigned char key_m = key_state_0;
    static unsigned char key_time_1 = 0;
    unsigned char key_temp,key_press;

    KEY_event_t key_return = KEY_Event_NULL;

    key_press = GPIOB_ReadPortPin(GPIO_Pin_0);                    // I/Oƽ
    switch (key_state)
    {
        case key_state_0:                              // ʼ̬
        if (!key_press) key_state = key_state_1;      // £״̬תȷ״̬
        break;

        case key_state_1:                      // ȷ̬
        if (!key_press)
        {
             key_time = 0;                   //
             key_state = key_state_2;   // Ȼڰ£ɣ״̬ת¼ʱļʱ״̬صĻ޼¼
        }
        else
             key_state = key_state_0;   // ̧תʼ̬˴ɺʵʵİºͷŶڴġ
        break;

        case key_state_2:
        if(key_press)
        {
             key_return = KEY_Event_Click;        // ʱͷţ˵ǲһζ̲S_key
             key_state = key_state_0;   // תʼ̬
        }
        else if (++key_time >= 180)     // £ʱ10ms10msΪѭִм
        {
             key_return = KEY_Event_Press;        // ʱ>1000ms˰Ϊس¼
             key_state = key_state_3;   // תȴͷ״̬
        }
        break;

        case key_state_3:                 // ȴͷ״̬״ֻ̬ް¼
        if (key_press) key_state = key_state_0; //ͷţתʼ̬
        break;
    }

    key_temp = key_return;

    switch(key_m)
    {
        case key_state_0:
            if (key_temp == KEY_Event_Click )
            {
                 key_time_1 = 0;               // 1εأ¸״̬жϺǷ˫
                 key_m = key_state_1;
                 key_return = 0 ;
            }
            else
                 key_return = key_temp;        // ޼ԭ¼
            break;

        case key_state_1:
            if (key_temp == KEY_Event_Click)             // һε϶<500ms
            {
                 key_return = KEY_Event_DoubleClick;           // ˫¼سʼ״̬
                 key_m = key_state_0;
            }
            else
            {                                  // 500msڿ϶Ķ޼¼Ϊ>1000ms1sǰͲ㷵صĶ޼
                 if(++key_time_1 >= 35)
                 {
                      key_return = KEY_Event_Click;      // 500msûٴγֵ¼һεĵ¼
                      key_m = key_state_0;     // سʼ״̬
                 }
             }
             break;
    }
    return key_return;
}


/*********************************************************************
 * @fn      GPIOB_IRQHandler
 *
 * @brief   GPIOBжϺ
 *
 * @return  none
 */
__INTERRUPT
__HIGH_CODE
void GPIOB_IRQHandler(void)
{
    //GPIOA_ClearITFlagBit(GPIO_Pin_6 | GPIO_Pin_5);
    PRINT("Hello \n");
    GPIOB_ClearITFlagBit(GPIO_Pin_0);
}

