/*
 *      uRTC.C
 *      Created on: 2024627
 *      Author: Tyt85
   *         ע⣺лHSEʱԴȴȶʱѡþйأѡһµľĶṩľ弰
 صݲֵͨR8_XT32M_TUNEĴòͬĸصݺƫõȶʱ䡣
 */

#include "CH58x_common.h"
#define PM_LOWPOWER_IDLE (0)
#define PM_LOWPOWER_HALT (0)
#define PM_LOWPOWER_SLEEP (0)
#define PM_LOWPOWER_SHUTDOWN (0)

#define  PM_RTC_WAKE (1)

void RTC_TimerAdjust(uint16_t y, uint16_t mon, uint16_t d, uint16_t h, uint16_t m, uint16_t s)
{
    LClk32K_Select(Clk32K_LSE);//ⲿ32K
    R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;
    R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;
    R8_CK32K_CONFIG |= RB_CLK_XT32K_PON;
    R8_SAFE_ACCESS_SIG = 0;

    RTC_InitTime(y,mon,d,h,m,s);

    printf("Init RTC OK\r\n");
}


void RTC_Init(void)
{
    #if PM_RTC_WAKE
      RTC_TimerAdjust(2024,7,13,11,52,30);

      //RTC_TMRFunCfg(Period_16_S);
      //PFIC_EnableIRQ(RTC_IRQn);
    //  PWR_PeriphWakeUpCfg( ENABLE, RB_SLP_RTC_WAKE, Long_Delay);          /*˯߻ʹ*/

    #endif
}

extern  volatile uint8_t Half_Second_Flag ;
__attribute__((interrupt("WCH-Interrupt-fast")))
__attribute__((section(".highcode")))
void RTC_IRQHandler(void)
{
  UINT16 py; UINT16 pmon; UINT16 pd; UINT16 ph; UINT16 pm; UINT16 ps;
  RTC_GetTime(&py,&pmon,&pd,&ph,&pm,&ps);
    if (RTC_GetITFlag(RTC_TMR_EVENT)) {
        printf("%d%d%d%dʱ%d%d\r\n",py,pmon,pd,ph,pm,ps);
        if(Half_Second_Flag)
            Half_Second_Flag = 0 ;
        else
        {
            Half_Second_Flag = 1 ;
        }
        RTC_ClearITFlag(RTC_TMR_EVENT);
    }
    if (RTC_GetITFlag(RTC_TRIG_EVENT))
        RTC_ClearITFlag(RTC_TRIG_EVENT);
}
